package eu.nk2.cache;

import reactor.core.publisher.Mono;

import java.util.function.BiFunction;
import java.util.function.Function;

public class MonoUtils {
  public static <V, T> Mono<T> wrapDangerousMonoFunction(Function<V, Mono<T>> supplier, V value) {
    try {
      return supplier.apply(value);
    } catch (Throwable t) {
      return Mono.error(t);
    }
  }

  public static <U, V, T> Mono<T> wrapDangerousMonoFunction(BiFunction<U, V, Mono<T>> supplier, U value, V value2) {
    try {
      return supplier.apply(value, value2);
    } catch (Throwable t) {
      return Mono.error(t);
    }
  }
}
