package eu.nk2.graphql;

import com.fasterxml.jackson.annotation.JsonIgnore;
import graphql.GraphQLError;
import org.springframework.http.HttpStatus;
import org.springframework.web.server.ResponseStatusException;

public abstract class BaseGraphQlException extends ResponseStatusException implements GraphQLError {
  public BaseGraphQlException(HttpStatus status, String reason) {
    super(status, reason);
  }

  public abstract String errorMessage();
  @Override
  public String getMessage() {
    return errorMessage();
  }

  @Override
  @JsonIgnore
  public StackTraceElement[] getStackTrace() {
    return super.getStackTrace();
  }
}
