package eu.nk2.graphql

import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import graphql.language.Field
import graphql.schema.DataFetchingEnvironment

fun readJsonMap(gson: Gson, variables: String?): Map<String, Any>? = variables?.let { gson.fromJson(it, TypeToken.getParameterized(Map::class.java, String::class.java, Any::class.java).type) }

val Field.childFields
  get() = this.selectionSet?.selections?.filterIsInstance<Field>()?.map { it } ?: listOf()