package eu.nk2.graphql.batch

import org.dataloader.DataLoader
import org.dataloader.DataLoaderOptions
import org.dataloader.DataLoaderRegistry

fun <T: Any, ID: Any> List<BatchedService<T, ID>>.makeRegistry(options: DataLoaderOptions): DataLoaderRegistry {
  val registry = DataLoaderRegistry()
  for (it in this) {
    val batchLoader = it.makeBatchLoader()
    registry.register(it.dataLoaderKey, DataLoader.newMappedDataLoader(batchLoader, options))
  }

  return registry
}
