package eu.nk2.graphql.data

import graphql.ExecutionInput
import graphql.ExecutionResult
import graphql.GraphQL
import org.dataloader.DataLoaderRegistry
import reactor.core.publisher.Mono

data class GraphQlContext<CTX>(
  private val graphQl: GraphQL,
  private val context: CTX,
  private val dataLoaderRegistry: DataLoaderRegistry
) {

  fun executeQuery(executionInput: ExecutionInput.Builder): Mono<ExecutionResult> =
    Mono.fromFuture(graphQl.executeAsync(
        executionInput.context(context)
          .dataLoaderRegistry(dataLoaderRegistry)
    ))
}
