package eu.nk2.ref

import eu.nk2.ref.abstract.DocumentWithId
import org.springframework.data.mongodb.core.mapping.Document
import org.springframework.data.mongodb.core.mapping.MongoId

@Document data class Ref<ID, Document: DocumentWithId<ID>>(
    @MongoId val id: ID
) {
  fun mockDocument(): Document = DummyDocumentId(id) as Document

  companion object {
    inline fun <reified ID: Any, Document: DocumentWithId<ID>> from(ref: Document) =
      Ref<ID, Document>(id = ref.provideId())
  }
}
